#ifndef _Color_H_
#define _Color_H_

#include <string>

struct RGB {
    double r; // 0..1
    double g; // 0..1
    double b; // 0..1
};

struct HSB {
    double h; // 0..360
    double s; // 0..1
    double b; // 0..1
};

class Color {
    public:
        Color(const RGB& rgb);
        Color(const HSB& hsb);
        Color(const std::string& hex);

        operator RGB() const { return _rgb; }
        operator HSB() const;
        std::string hex() const;

        Color& operator=(const RGB& rgb);
        Color& operator=(const HSB& hsb);
        Color& operator=(const std::string& hex);

    private:
        RGB _rgb;
};

#endif // _Color_H_
